/*+
|                                               |
|     Trigger: DTULTATU_NACIONALIDADE           |  
|     Tabela : NACIONALIDADE                    |
|                                               |
|     Criao:                                  |
|     19/07/2007 - Luiz Passos                  |
|                                               |
+*/

create or replace TRIGGER DTULTATU_NACIONALIDADE
BEFORE INSERT OR UPDATE OR DELETE
ON NACIONALIDADE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNACI := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDNACIONALIDADE,0) <> NVL(:NEW.CDNACIONALIDADE,0)) OR
           (NVL(:OLD.NMNACIONALIDADE,0) <> NVL(:NEW.NMNACIONALIDADE,0)) THEN
         :NEW.DTULTATUNACI := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NACIONALIDADE'  , '', 'CDNACIONALIDADE='||:OLD.CDNACIONALIDADE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NACIONALIDADE MODIFY DTULTATUNACI DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_NACIONALIDADE','5.01.008'); END;
/

